<p align="center">
    <img src="https://bayareawebpro.github.io/laravel-micro.js/logo.svg" alt="LaravelMicro.js">
</p>
<h3 align="center">
    <strong><code>npm install laravel-micro.js --save-dev</code></strong>
</h3>
<p align="center">
    <img src="https://github.com/bayareawebpro/laravel-micro.js/workflows/ci/badge.svg">
    <img src="https://codecov.io/gh/bayareawebpro/laravel-micro.js/branch/master/graph/badge.svg">
    <img src="https://img.shields.io/badge/License-MIT-brightgreen.svg">
    <img src="https://img.shields.io/badge/Dependencies-none-brightgreen.svg">
    <img src="https://img.shields.io/badge/DevDependencies-latest-brightgreen.svg">
    <img src="https://img.shields.io/badge/Version-1.x-blue.svg">
</p>

<p align="center">
    <strong>A Laravel style frontend framework that works with your UI framework of choice.</strong>
</p>


<p align="center">
LaravelMicro.js is an IOC Container, Service Locator Pattern and Middleware Pipeline for your 
Laravel Frontend. It provides true dependency injection, and a familiar design that encourages 
you to use object oriented principles in your client-side application.  It includes a DotSyntax 
Object Repository and Validator Service making it easy to work with data provided by 
Laravel Responses.
</p>

<p align="center">
<a href="https://bayareawebpro.github.io/laravel-micro.js/">Documentation</a>
| <a href="https://github.com/bayareawebpro/laravel-micro-spa-boilerplate">Project Starter</a>
| <a href="https://discord.gg/ScYhenF">Discord Channel</a>
</p>

---

### Features
Compatible with Reactive Frameworks like Vue.js and React.

* IOC Container
* Dependency Injection
* Router Integration
* Service Providers
* Error Handling
* Lazy Loading
* Middleware
* Repository
* Stringable
* Validator
* Mixins

> More Packages: https://github.com/bayareawebpro/laravel-micro.js/wiki/Other-Packages

--- 

#### Contributions

If your interesting in contributing to this project CI 
will run the Test Suite and Coverage Report for pull requests on 
the master branch.  Feel free to submit features that add 
parity with Laravel's conventions.

--- 

#### Contributors

A big thank you to contributors who have helped evolve this project:

* Pablo Hernández (Stringable, Container Alias Methods)

> Disclaimer: 
> This is a community project and not an official Laravel package. 
> Laravel is a trademark of Taylor Otwell.
